dnl AC_XERCES(variable, [action-if-found], [action-if-not-found])
dnl checks for xerces-c++ headers and libs in some common places.
AC_DEFUN([AC_XERCES],[
    AC_ARG_WITH(
	[xerces-incdir], 
	AC_HELP_STRING(
		[--with-xerces-incdir=DIR], 
		[Optionally specifies location of the xerces-c++ includes]),
        [xerces_incdir=$withval],
	[xerces_incdir=[.]])
    AC_ARG_WITH(
	[xerces-libdir], 
	AC_HELP_STRING(
		[--with-xerces-libdir=DIR], 
		[Optionally specifies location of the xerces-c++ library]),
        [xerces_libdir=$withval],
	[xerces_libdir=[.]])
    xerces_lib_paths="$xerces_libdir"
    xerces_inc_paths="$xerces_incdir /usr/local/include/xerces /usr/include/xerces /usr/local/include /usr/include"

    $1_CFLAGS=
    $1_LIBS=

    xerces_saved_CFLAGS="$CPPFLAGS"
    xerces_saved_LIBS="$LIBS"

    for xerces_path in $xerces_inc_paths; 
    do
        ifelse(	$xerces_path, 
		[.], 
		CPPFLAGS="$xerces_saved_CFLAGS", 
		CPPFLAGS="-I$xerces_path $xerces_saved_CFLAGS")
        AC_PREPROC_IFELSE(
            [#include <xercesc/sax2/DefaultHandler.hpp>],
            [xerces_h_found=yes; xerces_flags="$xerces_path"; break],
            [xerces_h_found=no])
    done

    for xerces_path in $xerces_lib_paths; do
        ifelse(	$xerces_path, 
		[.], 
		LIBS="$xerces_saved_LIBS", 
		LIBS="-L$xerces_path $xerces_saved_LIBS")
        AC_CHECK_LIB(
		[xerces-c], 
		[main],
            	[xerces_l_found=yes; xerces_libs="$xerces_path"; break],
            	[xerces_l_found=no; unset ac_cv_lib_xerces-c_main], -lpthread)
    done

    CPPFLAGS="$xerces_saved_CFLAGS"
    LIBS="$xerces_saved_LIBS"

    if test x$xerces_h_found = xyes && test x$xerces_l_found = xyes;
 then
        if test x$xerces_flags != x.; then
            $1_CFLAGS="-I$xerces_flags"
        fi
        if test x$xerces_libs = x.; then
            $1_LIBS="-lxerces-c"
        else
            $1_LIBS="-L$xerces_libs -lxerces-c"
        fi

        ifelse([$2], [], :, [$2])
    else
        ifelse([$3], [], :, [$3])
    fi
])
