dnl Available from the GNU Autoconf Macro Archive at:
dnl http://www.gnu.org/software/ac-archive/htmldoc/check_zlib.html
dnl
AC_DEFUN([ZLIB], [
dnl save environment 
zlib_save_CPPFLAGS="$CPPFLAGS"
zlib_save_LDFLAGS="$LDFLAGS"
AC_LANG_PUSH(C)

dnl define search path 
zlib_search="/usr/local /usr"
AC_ARG_WITH([zlib],
	[  --with-zlib=DIR    root directory path of zlib installation], 
	[if test "$withval" != no ; then
  		zlib_search="$withval $zlib_search"
  	fi], 
	[])

dnl search in all path 
HAVE_ZLIB=no
for dir in $zlib_search  
do 
	if  test "$HAVE_ZLIB"  = "no" ; then 
		zlib_home="$dir"
		zlib_cppflags="-I$zlib_home/include" 
		zlib_ldflags="-L$zlib_home/lib" 
	  	if test -f "${zlib_home}/include/zlib.h" ; then 
			CPPFLAGS="$zlib_cppflags $zlib_save_CPPFLAGS"
			LDFALGS="$zlib_ldflags $zlib_save_LDFLAGS"
	    		AC_CHECK_HEADER(zlib.h, [zlib_cv_zlib_h=yes], [zlib_cv_zlib_h=no])
			AC_CHECK_LIB(z, inflateEnd, [zlib_cv_libz=yes], [zlib_cv_libz=no])
			if  test "$zlib_cv_libz" = "yes" -a "$zlib_cv_zlib_h" = "yes" ; then 
				HAVE_ZLIB=yes
				ZLIB_CFLAGS="$zlib_cflags"
				ZLIB_LIBS="$zlib_ldflags -lz"
			fi
		fi
	fi
done
dnl if found update env 
if test "$HAVE_ZLIB" = "yes" ; then 
	AC_DEFINE_UNQUOTED([HAVE_ZLIB], [1], [zlib is available])
	AC_SUBST(HAVE_ZLIB)
	AC_SUBST(ZLIB_CFLAGS)
	AC_SUBST(ZLIB_LIBS)
fi
dnl restore previous environment 
AC_LANG_POP(C)
CPPFLAGS="$zlib_save_CPPFLAGS"
LDFLAGS="$zlib_save_LDFLAGS"
])
