/* -*- mode: c++; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/**
 *******************************************************************************
 * Utility Library 
 *******************************************************************************
 * @file
 * @brief Compatibility header 'util_base.hh'
 *  
 * 
 * 
 * - Created: 2005-08-05
 * - Creator: Olivier Delannoy
 * - Changelog: 
 *    
 *    * 2005-08-05 : Initial version  
 */
/*******************************************************************************
Copyright Olivier Delannoy 2005

Olivier Delannoy <Olivier.Delannoy@gmail.com>

This software is a computer program whose purpose is to [describe
functionalities and technical features of your software].

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 *******************************************************************************/
#ifndef UTIL_COMPAT_BASE_HH
#define UTIL_COMPAT_BASE_HH 1
#include "util_option.hh" //Load all build process information 

#if defined(__WIN32__) || defined(_WIN32)
#  if defined(UTIL_BUILD)
#    define UTIL_EXPORT __declspec(dllexport)
#  else 
#    define UTIL_EXPORT __declspec(dllimport)
#  endif
#    define UTIL_PRIVATE
#else 
#  define UTIL_EXPORT
#  define UTIL_IMPORT
#  define UTIL_PRIVATE 
#endif 

// Kill warning on VC6 when message are longer than 255 chars 
#if defined(_MSC_VER) && (_MSC_VER <= 1200)
#  pragma warning(disable : 4768)
#endif


#define UTIL_INT8  char
#define UTIL_INT16 short 
#define UTIL_INT32 int 
#define UTIL_INT64 long long 
#define UTIL_REAL32 float 
#define UTIL_REAL64 double 

#if defined(UTIL_OPT_STL)
#  include <string>
#  define UTIL_STRING std::string 
#endif 

#if defined(UTIL_OPT_DEBUG)
#  define UTIL_DEBUGUTIL(msg)                                           \
    std::cerr << "UTILDEBUG(" << __FILE__ << ':' << __LINE__ << ") " << msg << std::endl;
#else 
#  define UTIL_DEBUGUTIL(msg)
#endif 
#endif // guard UTIL_COMPAT_BASE_HH



